moFillTypeMovers = {};
source(MultiOverlayV3.modDir.."scripte/module/filltypemovers/moFillTypeMoversConfig.lua");

function moFillTypeMovers:update(dt)
	if moModule.active.filltypemovers.isRunning then
		if moFillTypeMovers.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateFillTypeMovers"] ~= nil then return;end; 
			moSetGetExtras:addTimer( {delay=moFillTypeMovers.values.updateTimer, name="updateFillTypeMovers", repeatable=1, ms=moFillTypeMovers.values.msec, action=moFillTypeMovers.load} )
		else
			moFillTypeMovers:loadfillTypeMovers();
		end;
	end;
end;

function moFillTypeMovers:load()	
	moFillTypeMovers:loadFillTypeMovers();	
end;

function moFillTypeMovers:loadFillTypeMovers()	
	local playerFarmId = g_currentMission.player.farmId;
	moFillTypeMovers.values.factorys = {}; --new 
	if moModule.fillTypeMovers ~= nil and #moModule.fillTypeMovers > 0 then
		local deleteObject = {};
		for index=1, #moModule.fillTypeMovers do
			if moModule.fillTypeMovers[index] ~= nil then
				local isObject = moModule:isObject(moModule.fillTypeMovers[index].object);
				if isObject then
					local factory = moModule.fillTypeMovers[index].object;
					if factory.ownerFarmId == 0 or factory.ownerFarmId == playerFarmId then
						local factoryName = moModule.fillTypeMovers[index].xmlName;
						if moFillTypeMovers.values.factorys[factoryName] == nil then moFillTypeMovers.values.factorys[factoryName] = {};end;
						moFillTypeMovers.values.factorys[factoryName][#moFillTypeMovers.values.factorys[factoryName]+1] = {general={},output={},input={}};
						
						local lineTableGeneral = moFillTypeMovers.values.factorys[factoryName][#moFillTypeMovers.values.factorys[factoryName]].general;
						lineTableGeneral[#lineTableGeneral+1] = {};
						local isLineTableGeneral = lineTableGeneral[#lineTableGeneral];						
						isLineTableGeneral.object = factory;
						isLineTableGeneral.ownerFarmId = factory.ownerFarmId or 0;
						isLineTableGeneral.objectName = moModule.fillTypeMovers[index].name;
						if moModule.fillTypeMovers[index].mohDisplayName ~= nil then isLineTableGeneral.objectName = moModule.fillTypeMovers[index].mohDisplayName;end;
						isLineTableGeneral.xmlName = factoryName;	
						isLineTableGeneral.productivity = 0; 
						isLineTableGeneral.productivityName = moLanguageXml:getTxt("productivity", nil, g_i18n:getText("statistic_productivity"));
						isLineTableGeneral.productivityColor = 1;
						---
						local capacityIn, fillLevelIn, fillTypesTotalIn, capacityOut, fillLevelOut, fillTypesOut = moFillTypeMovers:getFillTypeLevels(factory.storages[1], moModule.fillTypeMovers[index].fillTypeMoverTable)
						local input = nil;
						local output = nil;
						--output
						if #fillTypesOut > 0 then
							local lineTableOutput = moFillTypeMovers.values.factorys[factoryName][#moFillTypeMovers.values.factorys[factoryName]].output;
							output = lineTableOutput;
							for output=1, #fillTypesOut do
								lineTableOutput[#lineTableOutput+1] = {};
								local isLineTableOutput = lineTableOutput[#lineTableOutput];								
								local fillType = moFillTypes.values.fillTypes[fillTypesOut[output]];
								if fillType ~= nil then
									isLineTableOutput.fillTypeName = fillType.name;									
								else
									isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
								end;							
								isLineTableOutput.fillTypesTotal = fillTypesOut;
								isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelOut[output], 0));
								isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacityOut[output], 0));
								isLineTableOutput.percentageCapacity = math.floor(100 * (fillLevelOut[output]/capacityOut[output]));
							end;
						end;
						--output
						--input
						local totalFillLevel = 0;
						local totalCapacity = 0;
						if #fillTypesTotalIn > 0 then
							local lineTableInput = moFillTypeMovers.values.factorys[factoryName][#moFillTypeMovers.values.factorys[factoryName]].input;
							input = lineTableInput;
							--for input=1, #fillTypesTotalIn do
								lineTableInput[#lineTableInput+1] = {};
								local isLineTableInput = lineTableInput[#lineTableInput];								
								local fillType = moFillTypes.values.fillTypes[fillTypesTotalIn[1]];
								if fillType ~= nil then
									isLineTableInput.fillTypeName = fillType.name;									
								else
									isLineTableInput.fillTypeName = moLanguageXml:getTxt("fillcontainer", nil, "Fillcontainer");
								end;							
								isLineTableInput.fillTypesTotal = fillTypesTotalIn;
								isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelIn, 0));
								isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacityIn, 0));
								isLineTableInput.percentageCapacity = math.floor(100 * (fillLevelIn/capacityIn));
								totalFillLevel = totalFillLevel+Utils.getNoNil(fillLevelIn, 0);
								totalCapacity = totalCapacity+Utils.getNoNil(capacityIn, 0);
							--end;
						end;
						--input
						isLineTableGeneral.productivityObject = moFillTypeMovers:isProductivityObject(input, output); --or storage ! test !
						if isLineTableGeneral.productivityObject and totalCapacity > 0 and totalFillLevel > 0 then
							isLineTableGeneral.productivity = g_i18n:formatNumber(Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100);
							isLineTableGeneral.productivityColor = MultiOverlayV3:get_hl("getProzentColor", {Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100, true}, "getProzentColor Productivity FillTypeMovers");
						end;						
					end;
				else	
					table.insert(deleteObject, index);				
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.fillTypeMovers, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;
end;			

function moFillTypeMovers:getFillTypeLevels(fillTypeModule, fillTypeMover)
	local out1 = Utils.getNoNil(g_fillTypeManager:getFillTypeIndexByName(fillTypeMover.out1), 0);
	local out2 = Utils.getNoNil(g_fillTypeManager:getFillTypeIndexByName(fillTypeMover.out2), 0);
	local fillLevelTotalIn = 0;
	local fillTypesTotalIn = {};
	local capacityTotalIn = 0;
	local fillLevelOut = {};
	local fillTypesOut = {};
	local capacityOut = {};
	if fillTypeModule ~= nil and type(fillTypeModule) == "table" then		
		for fillTypeIndex, isAccepted in pairs(fillTypeModule.fillTypes) do
			if isAccepted then
				if (out1 ~= nil and out1 ~= 0 and fillTypeIndex == out1) or (out2 ~= nil and out2 ~= 0 and fillTypeIndex == out2) then					
					table.insert(fillLevelOut, Utils.getNoNil(fillTypeModule:getFillLevel(fillTypeIndex), 0))
					table.insert(capacityOut, Utils.getNoNil(fillTypeModule:getCapacity(fillTypeIndex), 0));
					table.insert(fillTypesOut, fillTypeIndex);
				else
					fillLevelTotalIn = fillLevelTotalIn+Utils.getNoNil(fillTypeModule:getFillLevel(fillTypeIndex), 0);
					capacityTotalIn = capacityTotalIn+Utils.getNoNil(fillTypeModule:getCapacity(fillTypeIndex), 0);
					table.insert(fillTypesTotalIn, fillTypeIndex);
				end;
			end;
		end;
	end;
	return capacityTotalIn, fillLevelTotalIn, fillTypesTotalIn, capacityOut, fillLevelOut, fillTypesOut;
end;

function moFillTypeMovers:isProductivityObject(input, output)
	if input == nil or output == nil then return false;end;
	if #input > 1 or #output > 1 or #input[1].fillTypesTotal > 1 or #output[1].fillTypesTotal > 1 then return true;end;	
	if #input[1].fillTypesTotal == 1 and #output[1].fillTypesTotal == 1 then
		local inputFillTypes = moFillTypes.values.fillTypes[input[1].fillTypesTotal[1]];
		local outputFillTypes = moFillTypes.values.fillTypes[output[1].fillTypesTotal[1]];
		if inputFillTypes ~= nil and outputFillTypes ~= nil then
			return inputFillTypes ~= outputFillTypes;
		end;
	end;
	return true;
end;

