missions = {};

--needs module missions
--lineType 2/missions
function missions:load()
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=3, txtScroll={leftRight=true,upDown=true}};
	if moMissions.values.missions ~= nil and #moMissions.values.missions > 0 then		
		lineTable[#lineTable+1] = {};
		local isLineTable = lineTable[#lineTable];
		
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = missions.returnLineHelpIconClick
		isLineTable.helpTxt = "Click MissionName for MapHotSpot(Only FieldMissions) or % for FillType Category or Price\nOr Map Missions for Open Page Menue\nMowBale = #S for Silage and #H for Hay";		
		
		isLineTable.txt = {};
		isLineTable.txt[1] = {};									
		isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map Missions (".. tostring(#moMissions.values.missions).. ")";
		isLineTable.txt[1].txtPos = 1;
		isLineTable.txt[1].clickCallback = missions.returnClickMissionsTotal;
		
		lineTable[#lineTable+1] = {};
		isLineTable = lineTable[#lineTable];		
		isLineTable.lineClickHelp = true;
		isLineTable.lineClickHelpCallback = missions.returnLineHelpIconSortByClick
		--isLineTable.helpTxt = "Click SortyBy ... for change";
		isLineTable.txt = {};
		isLineTable.txt[1] = {};									
		isLineTable.txt[1].clickCallback = missions.returnLineSortByClick;
		isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txtPos = 0;	
		isLineTable.txt[1].settingsButtonL = {"buttonLeft", moColors.intern["green"], missions.returnLineSortByClick};
		if moMissions.values.sortBy == 1 then
			isLineTable.txt[1].txt = "SortBy Price";
		elseif moMissions.values.sortBy == 2 then
			isLineTable.txt[1].txt = "SortBy Type";
		elseif moMissions.values.sortBy == 3 then
			isLineTable.txt[1].txt = "SortBy Hectar";
		else
			isLineTable.txt[1].txt = "SortBy Field";	
		end	
		local firstFarmIdPos = 3;		
		for index=1, #moMissions.values.missions do		
			if moMissions.values.missions[index] ~= nil then			
				local mission = moMissions.values.missions[index];
				local isRunning = mission.isRunning or (mission.status == AbstractMission.STATUS_RUNNING or mission.status == AbstractMission.STATUS_FINISHED);
				if isRunning and mission.farmId == playerFarmId then
					local txt = {};				
					table.insert(lineTable, firstFarmIdPos, txt);
					isLineTable = lineTable[firstFarmIdPos];					
				else
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];
				end;
				isLineTable.ownValues = {mission};
				isLineTable.txt = {};
				isLineTable.txt[1] = {};									
				isLineTable.txt[1].width = 20;	--width prozent
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[1].bold = moModule.values.txtBold;				
				isLineTable.txt[1].txt = g_i18n:formatMoney(mission.reward); --..  moLanguageXml:getTxt("moneysymbol", nil, "€");
				if mission.missionId ~= nil and mission.missionId > 0 then
					isLineTable.txt[1].clickCallback = missions.returnClickMissionsMoney;
					isLineTable.txt[1].missionId = mission.missionId;	
				end;
				isLineTable.txt[2] = {};									
				isLineTable.txt[2].width = 70;	--width prozent
				if isRunning then
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtActiveColor);
				else
					isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
				end;				
				local fillTypeMission = "";
				if mission.field ~= nil and mission.fillType ~= nil then
					if tostring(mission.typeName):lower() == "mow_bale" then
						if mission.fillType == FillType.SILAGE then fillTypeMission = " #SI";else fillTypeMission = " #HE";end;
					elseif moFillTypes.values.fillTypes[mission.fillType] ~= nil then
						fillTypeMission = " #".. string.sub(moFillTypes.values.fillTypes[mission.fillType].name, 1,3):upper();
					end;
				end;
				isLineTable.txt[2].bold = moModule.values.txtBold;				
				isLineTable.txt[2].txt = tostring(mission.className).. fillTypeMission;				
				isLineTable.txt[2].txtPos = 1;
				if moModule.values.languageXml then
					isLineTable.txt[2].txt = moLanguageXml:getTxt("mission".. tostring(mission.typeName):lower(), nil, mission.className).. fillTypeMission;
				end;				
				local transport = false;
				if mission.numObjects ~= nil and mission.numObjects > 0 then
					transport = true;
					isLineTable.txt[2].transport = true;
					isLineTable.txt[2].txt = isLineTable.txt[2].txt.. " #".. tostring(mission.numObjects);
					isLineTable.txt[2].clickCallback = missions.returnClickMissionsName;
				elseif mission.field ~= nil and mission.fieldId > 0 then
					isLineTable.txt[2].txt = isLineTable.txt[2].txt.. " (F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ha";
				end;
				if mission.isLeasing then isLineTable.txt[2].txt = "L# "..isLineTable.txt[2].txt;end; 
				if mission.field ~= nil then
					isLineTable.txt[2].field = mission.field;
					isLineTable.txt[2].clickCallback = missions.returnClickMissionsName;					
				end;
				if mission.sellPointId ~= nil then
					isLineTable.txt[2].sellPointId = mission.sellPointId;
					isLineTable.txt[2].clickCallback = missions.returnClickMissionsName;
				end;
				isLineTable.txt[3] = {};									
				isLineTable.txt[3].width = 10;	--width prozent
				isLineTable.txt[3].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[3].bold = moModule.values.txtBold;
				isLineTable.txt[3].txt = tostring(mission.prozent).. "%";
				isLineTable.txt[3].txtPos = 2;
				if mission.field ~= nil and mission.fillType ~= nil then
					isLineTable.txt[3].clickCallback = missions.returnClickMissionsFillType;
					isLineTable.txt[3].fillTypeName = moFillTypes.values.fillTypes[mission.fillType].name;					
				end;
				local farmColor = moSetGetExtras:getColorForFarm(mission.farmId)
				if isRunning and mission.farmId ~= playerFarmId then --hidden					
					isLineTable.ownValues = nil;
					isLineTable.txt[1].txt = "-"
					isLineTable.txt[1].bold = false;
					isLineTable.txt[1].clickCallback = nil;
					isLineTable.txt[2].txt = "----"
					isLineTable.txt[2].bold = false;
					isLineTable.txt[2].color = farmColor;
					isLineTable.txt[2].clickCallback = nil;
					isLineTable.txt[3].txt = "-"
					isLineTable.txt[3].bold = false;
					isLineTable.txt[3].clickCallback = nil;
				elseif mission.status == AbstractMission.STATUS_FINISHED then					
					isLineTable.txt[3].txt = moLanguageXml:getTxt("finish", nil, "Finish");					
				--elseif isRunning and mission.status == AbstractMission.STATUS_STOPPED then					
				--	isLineTable.txt[3].txt = "Cancel";	
				end;
				missions:setHotspot(playerFarmId, farmColor, mission.object, transport);				
			end;
		end;		
	end;	
	missions.output= lineTable;
end;

function missions:setHotspot(playerFarmId, farmColor, mission, transport)
	if MultiOverlayV3.otherMods.betterContracts ~= nil then return;end;
	if not transport then
		for fieldIndex, missionT in pairs (moMissions.values.fieldToMission) do
			local field = g_fieldManager:getFieldByIndex(fieldIndex); --g_fieldManager.fields[fieldIndex];
			if field ~= nil then				
				if missionT.mohMissionBlinking == nil then missionT.mohMissionBlinking = false;end;		
				if missionT ~= nil and missionT.status ~= 0 then
					if missionT.farmId == playerFarmId and not missionT.mohMissionBlinking then
						missionT.mohMissionBlinking = true;						
						missions:createHotSpotFieldMission(missionT);
					end;
				else					
					moMissions.values.fieldToMission[fieldIndex] = nil;
				end;			
			end;
		end;
	else
		if mission ~= nil and mission.status ~= 0 then
			if mission.mohMissionBlinking == nil then mission.mohMissionBlinking = false;end;
			if mission.farmId == playerFarmId and mission.pickupHotspot ~= nil and mission.dropoffHotspot ~= nil and not mission.mohMissionBlinking then
				mission.mohMissionBlinking = true;
				local overlay = mission.pickupHotspot;
				local overlay1 = mission.dropoffHotspot;
				if overlay ~= nil then
					overlay.blinking = true;
				end;
				if overlay1 ~= nil then
					overlay1.blinking = true;
				end;
			end;			
		end;
	end;
end;

function missions:createHotSpotFieldMission(mission)		
	if mission.mapHotspot ~= nil then
		g_currentMission:removeMapHotspot(mission.mapHotspot);
		mission.mapHotspot:delete();

		mission.mapHotspot = nil;
	end;
	local farmColor = moSetGetExtras:getColorForFarm(mission.farmId);
	local _, textSize = getNormalizedScreenValues(0, 9);
	local _, textOffsetY = getNormalizedScreenValues(0, 7);
	mission.mapHotspot = MapHotspot:new("field", MapHotspot.CATEGORY_FIELD_DEFINITION);
	local txtSize = Utils.getNoNil(mission.field.mapHotspot.textSize, textSize);
	mission.mapHotspot:setText(tostring(mission.field.fieldId), nil, true);
	mission.mapHotspot:setTextOptions(txtSize, true, textOffsetY, farmColor);
	mission.mapHotspot:setSize(0, 0);
	mission.mapHotspot:setWorldPosition(mission.field.posX, mission.field.posZ);
	mission.mapHotspot:setBlinking(true);
	mission.mapHotspot:setPersistent(true);
	mission.mapHotspot:setRenderLast(true);
	g_currentMission:addMapHotspot(mission.mapHotspot);
end


function missions.returnClickMissionsTotal(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			g_gui:showGui("InGameMenu");
			local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
			local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
			g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);
		end;
	end;
end;		

function missions.returnClickMissionsMoney(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			if g_currentMission.inGameMenu.pageContracts == nil then return;end;
			local missionId = missions.output[args.line].txt[1].missionId;
			g_gui:showGui("InGameMenu");
			local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
			local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
			g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);
			local selectMission = g_currentMission.inGameMenu.pageContracts.contractsList:getSelectedDataIndex();
			if g_currentMission.inGameMenu.pageContracts.contracts[selectMission] ~= nil and g_currentMission.inGameMenu.pageContracts.contracts[selectMission].mission.id ~= missionId then
				for a=1, #g_currentMission.inGameMenu.pageContracts.contracts do
					if g_currentMission.inGameMenu.pageContracts.contracts[a] ~= nil and g_currentMission.inGameMenu.pageContracts.contracts[a].mission.id == missionId then
						g_currentMission.inGameMenu.pageContracts.contractsList:setSelectedIndex(a);
						return;
					end;
				end;
			end;
		end;
	end;
end;

function missions.returnClickMissionsFillType(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			local fillTypeName = missions.output[args.line].txt[3].fillTypeName;
			g_currentMission:showBlinkingWarning("Mission FillType: ".. tostring(fillTypeName), 2000);
		end;
	end;
end;

function missions.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(missions.output[args.line].helpTxt);
		end;
	end;
end;

function missions.returnLineHelpIconSortByClick(...)	
	if ... ~= nil then		
		local args = ...;		
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.txt = "Click SortyBy ... for change\nand wait for the timer query\n(xml settings module missions updtaeTimer value)";		
	end;
end;

function missions.returnLineSortByClick(...)
	if ... ~= nil then		
		local args = ...;
		if moMissions.values.sortBy+1 > 4 then moMissions.values.sortBy = 1;else moMissions.values.sortBy = moMissions.values.sortBy+1;end;				
	end;
end;

function missions.returnClickMissionsName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil then			
			--Field:getCenterOfFieldWorldPosition			
			if missions.output[args.line].txt[2].field ~= nil then
				local x = missions.output[args.line].txt[2].field.posX;
				local z = missions.output[args.line].txt[2].field.posZ;
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot(nil, x, z);
				end;
			end;
			if missions.output[args.line].txt[2].sellPointId ~= nil then
				local x, y, z = getWorldTranslation(missions.output[args.line].txt[2].sellPointId);				
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot(nil, x, z, true);
				end;
			end;
			if missions.output[args.line].txt[2].transport ~= nil and missions.output[args.line].ownValues ~= nil and missions.output[args.line].ownValues[1] ~= nil then
				local mission = missions.output[args.line].ownValues[1];
				local trigger1 = g_missionManager.transportTriggers[mission.object.pickup];
				local trigger2 = g_missionManager.transportTriggers[mission.object.dropoff];
				if trigger1.triggerId ~= nil then
					local x, y, z = getWorldTranslation(trigger1.triggerId);
					if x ~= nil and x ~= 0 then
						moSetGetOverlays:mapHotSpot(nil, x, z);
					end;
				end;
				if trigger2.triggerId ~= nil then
					local x, y, z = getWorldTranslation(trigger2.triggerId);
					if x ~= nil and x ~= 0 then
						moSetGetOverlays:mapHotSpot(nil, x, z, true);
					end;
				end;				
			end;
		end;		
	end;
end;

function missions.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.missions.isRunning = true;moModule.active.missions.last = moModule.time.min+moModule.time.delay;		
		missions:load();
		return missions.output;				
	end;
end;

function missions.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--missions:load();	
end;

function missions:generateCmd()
	local _, errorTable = 0, {};
	function insertCmd()
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };		
		newCmdTable.cmdTable[1] = {
			cmdName = "mapMissions";
			displayName = "Map Missionen";		
			multiple = true;
			sortBy = "Missionen";
			infoTxt = "Zeigt alle missionen an";
			helpTxt = "View missions";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 3;
			typ = "output";
			action = missions.giveOutputTable; --a function
			ownValues = {}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate mapMissions Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;	 
	local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "mapMissions", "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
	if isAlreadyExits == nil then insertCmd();end;		
end;
