windturbinen = {};

--needs module windturbinen (no update)
--lineType 2/windturbinen
function windturbinen:load(windturbineName)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moModule.windturbinen ~= nil and #moModule.windturbinen > 0 then
		local deleteObject = {};
		for index=1, #moModule.windturbinen do		
			if moModule.windturbinen[index] ~= nil then			
				local windturbine = moModule.windturbinen[index];			
				local isObject = moModule:isObject(windturbine.object)
				if isObject then
					if windturbine.object.ownerFarmId == 0 or windturbine.object.ownerFarmId == playerFarmId then
						if windturbine.xmlName == windturbineName then
							lineTable[#lineTable+1] = {};
							local isLineTable = lineTable[#lineTable];			
							
							if #moModule.windturbinen > 1 and index ~= 1 then					
								isLineTable.setLineBorderNewObject = true;	
							end;							
							
							isLineTable.ownValues = {windturbineName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].nodeId = windturbine.object.nodeId;
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
							isLineTable.txt[1].bold = true;					
							local name = windturbine.name;
							if windturbine.mohDisplayName ~= nil then name = windturbine.mohDisplayName;end;
							local isNearObject = moModule:nearPlayerPosition(windturbine.object, 10);				
							if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = windturbinen.returnClickObjectName;end;					
							if isNearObject ~= nil and isNearObject then
								isLineTable.txt[1].txt = ">>".. name.. "<<";
							else
								isLineTable.txt[1].txt = name;
							end;
							isLineTable.txt[1].txtPos = 1;					
							---
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];			
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};
							isLineTable.txt[1].width = 70;	--width prozent	
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = moLanguageXml:getTxt("ages", nil, "Age");				
							isLineTable.txt[2] = {};
							isLineTable.txt[2].width = 30;	--width prozent	
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = tostring(windturbine.object.age).. " ".. moLanguageXml:getTxt("ageday", nil, "Day(s)");
							isLineTable.txt[2].txtPos = 2;
							---
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];			
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};
							isLineTable.txt[1].width = 70;	--width prozent	
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = moLanguageXml:getTxt("incomeperhour", nil, g_i18n:getText("shop_income"));				
							isLineTable.txt[2] = {};
							isLineTable.txt[2].width = 30;	--width prozent	
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
							isLineTable.txt[2].bold = moModule.values.txtBold;
							isLineTable.txt[2].txt = g_i18n:formatMoney(windturbine.object.incomePerHour); --moLanguageXml:getTxt("moneysymbol", nil, "€");	
							isLineTable.txt[2].txtPos = 2;
						end;
					end;
				else	
					table.insert(deleteObject, index);				
				end;			
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.windturbinen, index);
			end;
			moModule:slotOutputCmd(true);
		end;
	end;	
	windturbinen[windturbineName] = {output=lineTable};
end;

function windturbinen.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local windturbineName = args.ownValues[1];
			if windturbinen[windturbineName] ~= nil and windturbinen[windturbineName].output ~= nil and windturbinen[windturbineName].output[args.line] ~= nil then
				local nodeId = windturbinen[windturbineName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function windturbinen.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		--moModule.active.windturbinen.isRunning = true;moModule.active.windturbinen.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local windturbineName = args.ownValues[1];
			windturbinen:load(windturbineName);
			return windturbinen[windturbineName].output;
		end;		
	end;
end;

function windturbinen.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--windturbinen:load();	
end;

function windturbinen:generateCmd(windturbineName)
	local _, errorTable = 0, {};
	function insertCmd(windturbineName)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local windturbineNameTemp = tostring(windturbineName):lower();
		local languageName = moLanguageXml:getTxt(windturbineNameTemp, nil, windturbineName);
		newCmdTable.cmdTable[1] = {
			cmdName = "windturbinen_".. tostring(windturbineName);
			displayName = moLanguageXml:getTxt("windturbinen", nil, "Windturbinen").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Windturbinen";
			infoTxt = "Zeigt alle Windturbinen oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View Windturbinen or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;
			typ = "output";
			action = windturbinen.giveOutputTable; --a function
			ownValues = {windturbineName}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate Windturbinen Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if windturbineName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "windturbinen_".. windturbineName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(windturbineName);end;
	else
		if moModule.windturbinen ~= nil and #moModule.windturbinen > 0 then
			for index=1, #moModule.windturbinen do
				local windturbineName = moModule.windturbinen[index].xmlName;
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "windturbinen_".. windturbineName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(windturbineName);end;
			end;			
		end;
	end;	
end;
